{% extends "base.html" %}
{% load timeutil %}
{% load scientific %}
{% load sanitize_html %}
{% load logtags %}
{% block heading %}{% endblock %}
{% block bodyattrs %}class="tundra eventDetail"{% endblock %}

{% block jscript %}
{% load static %}
<link rel="stylesheet" href="{% static "css/labeltips.css" %}" />
<script src="{% static "moment/moment.js" %}"></script>
<script src="{% static "moment-timezone/builds/moment-timezone-with-data.min.js" %}"></script>
<script src="{% static "dojo/dojo.js" %}" data-dojo-config="async: true"></script>
<script src="{% static "jquery/dist/jquery.min.js" %}"></script>
<!-- Styles for dgrid -->
<!-- <link rel="stylesheet" href="{% static "dgrid/css/dgrid.css" %}" /> -->
<!-- Styles for the editor components -->
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/PageBreak.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/ShowBlockNodes.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/Preview.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/Save.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/Breadcrumb.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/FindReplace.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/PasteFromWord.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/InsertAnchor.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/CollapsibleToolbar.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/Blockquote.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/Smiley.css" %}" />
<!-- Styles for the lightboxes. --> 
<link rel="stylesheet" href="{% static "dojox/image/resources/LightboxNano.css" %}" />
<!-- Local style declarations -->
<link rel="stylesheet" href="{% static "dijit/themes/tundra/tundra.css" %}" />

<!-- the main JavaScript block is pulled in with an include -->
<script>
{% include "gracedb/event_detail_script.js" %}
</script>

{% endblock %}

{% block content %}
<div id='event_detail_content'>
{% if object.offline %}
<div style="text-align: center;">
    <h2 style="color: red;">OFFLINE EVENT</h2>
</div>
{% endif %}


<p>{{ message }}</p>

{% if 'lvem_view' not in request.path %}

<!-- XXX This next bit is super hacky. -->
{% if can_expose_to_lvem %}
<div class="content-area">
<form action="{% url "modify_permissions" object.graceid %}" method="post">
    <input type="hidden" name="group_name" value="{{ lvem_group_name }}">
    <input type="hidden" name="action" value="expose">
    <input type="submit" value="Expose this event to LV-EM" class="permButtonClass">
</form>
</div>
{% elif can_protect_from_lvem %}
<div class="content-area">
<form action="{% url "modify_permissions" object.graceid %}" method="post">
    <input type="hidden" name="group_name" value="{{ lvem_group_name }}">
    <input type="hidden" name="action" value="protect">
    <input type="submit" value="Revoke LV-EM permissions for this event" class="permButtonClass">
</form>
</div>
{% endif %}

<!-- Here is a section for the control room operator signoff -->
{% if operator_signoff_authorized and operator_signoff_active %}
    <div class="signoff-area">
    <h2> {{signoff_instrument}} Operator Signoff </h2>
    <p> You are seeing this section because you've connected from a machine that, 
    according to our records, is in the {{signoff_instrument}} control room. 
    {% if operator_signoff_object %}
    This event has already been signed off on.
    Use the form below if you wish to edit or delete the record. </p>
    <form action="{% url "modify_signoff" object.graceid %}" method="post">
        <table>
        <tr><th><label for="id_status">Status:</label></th><td><select id="id_status" name="status">
        <option value="">---------</option>
        {% if operator_signoff_object.status == "OK" %}
        <option value="OK" selected="selected">OKAY</option>
        <option value="NO">NOT OKAY</option>
        {% else %}
        <option value="OK">OKAY</option>
        <option value="NO" selected="selected">NOT OKAY</option>
        {% endif %}
        </select></td></tr>
        <tr><th><label for="id_comment">Comment:</label></th><td>
        <textarea cols="40" id="id_comment" name="comment" rows="10">{{operator_signoff_object.comment}}</textarea></td></tr>
        <input type="hidden" name="signoff_type" value="operator">
        <input type="hidden" name="action" value="edit">
        <tr> <th> Delete </th> <td> <input type="checkbox" name="delete" value="true"> </td> </tr>
        <tr> <td></td> <td> <input type="submit" value="Submit" class="searchButtonClass"> </td> </tr>
        </table>
    </form>

    {% else %}
    This event still requires operator signoff. </p> 
    <p> Please answer the following (and optionally enter a comment): At the time of the 
    {% if signoff_instrument == 'H1' %}
        event ({{ object.gpstime|gpsdate_tz:"lho" }}),
    {% elif signoff_instrument == 'L1' %}
        event ({{ object.gpstime|gpsdate_tz:"llo" }}),
    {% elif signoff_instrument == 'V1' %}
        event ({{ object.gpstime|gpsdate_tz:"virgo" }}),
    {% else %}
        event,
    {% endif %}
    was the operating status of the detector basically okay, or not? </p>
    <form action="{% url "modify_signoff" object.graceid %}" method="post">
        <table>
        {{ signoff_form.as_table }}
        <input type="hidden" name="signoff_type" value="operator">
        <input type="hidden" name="action" value="create">
        <tr> <td></td> <td> <input type="submit" value="Submit" class="searchButtonClass"> </td> </tr>
        </table>
    </form>
    {% endif %}
    </div>
{% endif %}

<!-- Here is a section for the EM advocate signoffs. -->
<!-- XXX So much ugliness here. Is there a way to do this with the JS? -->
{% if advocate_signoff_authorized and advocate_signoff_active %}
    <div class="signoff-area">
    <h2> Advocate Signoff </h2>
    <p> You are seeing this section because you're a designated EM followup 
    advocate.
    {% if advocate_signoff_object %}
    This event has already been signed off on.
    Use the form below if you wish to edit or delete the record. </p>
    <form action="{% url "modify_signoff" object.graceid %}" method="post">
        <table>
        <tr><th><label for="id_status">Status:</label></th><td><select id="id_status" name="status">
        <option value="">---------</option>
        {% if advocate_signoff_object.status == "OK" %}
        <option value="OK" selected="selected">OKAY</option>
        <option value="NO">NOT OKAY</option>
        {% else %}
        <option value="OK">OKAY</option>
        <option value="NO" selected="selected">NOT OKAY</option>
        {% endif %}
        </select></td></tr>
        <tr><th><label for="id_comment">Comment:</label></th><td>
        <textarea cols="40" id="id_comment" name="comment" rows="10">{{advocate_signoff_object.comment}}</textarea></td></tr>
        <input type="hidden" name="signoff_type" value="advocate">
        <input type="hidden" name="action" value="edit">
        <tr> <th> Delete </th> <td> <input type="checkbox" name="delete" value="true"> </td> </tr>
        <tr> <td></td> <td> <input type="submit" value="Submit" class="searchButtonClass"> </td> </tr>
        </table>
    </form>

    {% else %}
    This event still requires EM Followup advocate signoff. </p> 
    <form action="{% url "modify_signoff" object.graceid %}" method="post">
        <table>
        {{ signoff_form.as_table }}
        <input type="hidden" name="signoff_type" value="advocate">
        <input type="hidden" name="action" value="create">
        <tr> <td></td> <td> <input type="submit" value="Submit" class="searchButtonClass"> </td> </tr>
        </table>
    </form>
    {% endif %}
    </div>
{% endif %}

{% endif %} {# lvem_view not in request.path #}


<div class="content-area">
{% block basic_info %}
<h2> Basic Info </h2>

<table class="event">
    <tr>
            <th valign="top">UID</th>
            <th>Labels</th>
            <th>Group</th>
            <th>Pipeline</th>
            <th>Search</th>
            <th>Instruments</th>
            <th>
                <div id="basic_info_event_ts"></div>
                <div> Event Time </div>
            </th>
            <th>FAR (Hz)</th>
            <th>FAR (yr<sup>-1</sup>)</th>
            <th>Links</th>
            <th>
                <div id="basic_info_created_ts"></div>
                <div> Submitted </div>
            </th>
            {% if object.superevent %}
            <th>Superevent</th>
            {% endif %}
    </tr>
    <tr>
        <td>{{ object.graceid }}</td>
        <td>
             {% for labelling in object.labelling_set.all %}
                <span onmouseover="tooltip.show(tooltiptext('{{labelling.label.name}}', '{{labelling.creator.username}}', '{{labelling.created|utc}}', '{{labelling.label.description}}'));" onmouseout="tooltip.hide();"  style="color: {{labelling.label.defaultColor}};" class="label">{{ labelling.label.name }}</span>
             {% endfor %}
        </td>
        <td>{{ object.group.name }} </td>
        <td>{{ object.pipeline.name }} </td>
        <td>{{ object.search.name }} </td>
        <td>{{ object.instruments }}</td>
        <td>{% if object.gpstime %}
                <!-- <span title="{{ object.gpstime|gpsdate }}">{{ object.gpstime }}</span> -->
                {{ object.gpstime|multiTime:"gps" }}
            {% endif %}</td>
        {# NOTE: XXX Using event_far so it can be floored for external users. #}
        <td>{% if far_is_upper_limit %} &lt; {% endif %}{{ display_far|scientific }}</td>
        <td>{% if far_is_upper_limit %} &lt; {% endif %}{{ display_far_yr }}</td>
        <td><a href="{{ object.weburl }}">Data</a></td>
        <td>{{ object.created|multiTime:"created" }}</td>
        {% if object.superevent %}
        <td><a href="{{ object.superevent.get_web_url }}">{{ object.superevent.superevent_id }}</a></td>
        {% endif %}
    </tr>
</table>
{% endblock %}
</div>

<div class="content-area">
{% if user_is_external %}
{# Analysis-specific attributes which can be exposed to external partners #}
{% block external_analysis_specific %}
{# Empty by default #}
{% endblock %}
{% else %}
{# Analysis-specific attributes #}
{% block analysis_specific %}
{# This block is empty in the base event_detail template #}
{% endblock %}
{% endif %}
</div>

{# Neighbors #}
<script type="text/javascript">
    var refresh_neighbors= function() { alert("NOT SET YET"); };
    require(["dojo/dom", "dojo/html", "dojo/request", "dojo/domReady!"],
        function (dom, html, request) {
            refresh_neighbors = function(delta) {
                delta = delta.replace(/[ [\]]/g, "");
                if (delta.match(/^-?\d+$/) == null & delta.match(/^[-+]?\d+,[-+]?\d+$/) == null) {
                    alert("Bad neighborhood specified.")
                    return;
                }
                var neighborUrlPattern = "{% url "neighbors" object.graceid "000" %}"
                var neighbor_div = dom.byId("neighbors");
                neighborUrl = neighborUrlPattern.replace("000", delta);
                request(neighborUrl).then(
                    function(text){
                        html.set(neighbor_div, text, {parseContent:true} );
                    },
                    function(error){
                        inbox = '<input value="" size="6" onchange="refresh_neighbors(this.value)">'
                        html.set(neighbor_div, inbox+"<br>Failed to find neighbors.<br>"+error);
                    });
            };
        // refresh_neighbors("5");
    });
    require(["dijit/InlineEditBox", "dijit/form/NumberSpinner", "dijit/form/TextBox"]);
</script>

{% include "gracedb/neighbors_frag.html" %}

{% include "gracedb/emo_form_frag.html" %}

</div> <!-- end event_detail_content div -->
{% endblock %}

